library ieee;

use ieee.std_logic_1164.all;
use ieee.std_logic_signed.all;

entity calcolo2 is
	port (din: in std_logic_vector(7 downto 0);
	clk,nw: in std_logic;
	ris: out std_logic_vector(7 downto 0));
end calcolo2;

architecture beh of calcolo2 is
type stati is (idle, letta, lettb,calcola);
signal st: stati;
signal a,b: std_logic_vector(7 downto 0);
signal en_letta,en_lettb,en_calcola: std_logic;
begin 
process(clk)
begin
	if clk'event and clk='0' then 
		case st is
			when idle => if nw = '1' then st <= letta;
			             else st <= idle;
						 end if;
			when letta => st <= lettb;
			when lettb => st <= calcola;
			--when calcola => st <= idle;
			when others => st <= idle;
		end case;
	end if;
end process;

process(clk)
begin
	if clk'event and clk='0' then 
	 	if en_letta = '1' then 
		  a<= din; 
		end if;
		if en_lettb = '1' then 
	   	  b<= din;
		end if;
		if en_calcola = '1' then
		 ris <= A + B;
        end if;
	end if;
end process;

process(st)
begin
	case st is
		when letta =>
		en_letta <= '1';
		en_lettb <= '0';
		en_calcola <= '0';
		when lettb =>
		en_letta <= '0';
		en_lettb <= '1';
		en_calcola <= '0';
		when calcola  => 
		en_letta <= '0';
		en_lettb <= '0';
		en_calcola <= '1';
		when others =>
		en_letta <= '0';
		en_lettb <= '0';
		en_calcola <= '0';
   end case;
end process;

		  
end beh;


		 
			